/*****************************************************************************************
                                          
										   DXPy
							A Simple DirectX9 Wrapper for Python

*****************************************************************************************/
//File: dxpy_module.h
//Use: This is an extension of the file where the dxpy python module is implemented
//By: Daniel Kumor
//Filever: 0.21

//Makes sure that the header is included only once
#ifndef DXPY_MODULE_HEADER_EXTENSION
#define DXPY_MODULE_HEADER_EXTENSION

/****************************************************************************************/
//DXPY's Helper functions
/****************************************************************************************/
int GetMouseNumber(char* name)
{

	if (strcmp(name, "leftbutton")==0 || strcmp(name, "left")==0){
		return 0;
	}
	else if (strcmp(name, "rightbutton")==0 || strcmp(name, "right")==0){
		return 1;
	}
	else if (strcmp(name, "middlebutton")==0 || strcmp(name, "middle")==0){
		return 2;
	}
	else if (strcmp(name, "middlebuttonmove")==0 || strcmp(name, "middlemove")==0){
		return 3;
	}
	else if (strcmp(name, "move")==0 || strcmp(name,"mousemove")){
		return 4;
	}
	else
		return -1; //You FAIL
}

int GetKeyNumber(char* keyname) 
{
    /* This is a really long and boring function that processes what key
    was being binded from text to key number */
    
    //TODO: Some keys are not implemented!
    
    if (strcmp(keyname, "enter")==0) { //Named keys
        return DIK_RETURN;
    } 
    else if (strcmp(keyname,"escape")==0) {
        return DIK_ESCAPE;
    }
    else if (strcmp(keyname,"Lshift")==0) {
        return DIK_LSHIFT;
    }
    else if (strcmp(keyname,"Rshift")==0) {
        return DIK_RSHIFT;
    }
    else if (strcmp(keyname,"Lalt")==0) {
        return DIK_LMENU;
    }
    else if (strcmp(keyname,"Ralt")==0) {
        return DIK_RMENU;
    }
    else if (strcmp(keyname,"delete")==0) {
        return DIK_DELETE;
    }
    else if (strcmp(keyname,"insert")==0) {
        return DIK_INSERT;
    }
    else if (strcmp(keyname,"tab")==0) {
        return DIK_TAB;
    }
    else if (strcmp(keyname,"backspace")==0) {
        return DIK_BACK;
    }
    else if (strcmp(keyname,"plus")==0) { //+ and - keys
        return DIK_EQUALS;
    }
    else if (strcmp(keyname,"minus")==0) {
        return DIK_MINUS;
    }
    else if (strcmp(keyname,"equals")==0) {
        return DIK_EQUALS;
    }
    else if (strcmp(keyname,"spacebar")==0) { //spacebar
        return DIK_SPACE;
    }
    else if (strcmp(keyname,"up")==0) { //Arrow keys!
        return DIK_UP;
    }
    else if (strcmp(keyname,"down")==0) { 
        return DIK_DOWN;
    }
    else if (strcmp(keyname,"left")==0) { 
        return DIK_LEFT;
    }
    else if (strcmp(keyname,"right")==0) {
        return DIK_RIGHT;
    }
    else if (strcmp(keyname,"f1")==0) { //Function keys!
        return DIK_F1;
    }
    else if (strcmp(keyname,"f2")==0) {
        return DIK_F2;
    }
    else if (strcmp(keyname,"f3")==0) {
        return DIK_F3;
    }
    else if (strcmp(keyname,"f4")==0) {
        return DIK_F4;
    }
    else if (strcmp(keyname,"f5")==0) {
        return DIK_F5;
    }
    else if (strcmp(keyname,"f6")==0) {
        return DIK_F6;
    }
    else if (strcmp(keyname,"f7")==0) {
        return DIK_F7;
    }
    else if (strcmp(keyname,"f8")==0) {
        return DIK_F8;
    }
    else if (strcmp(keyname,"f9")==0) {
        return DIK_F9;
    }
    else if (strcmp(keyname,"f10")==0) {
        return DIK_F10;
    }
    else if (strcmp(keyname,"f11")==0) {
        return DIK_F11;
    }
    else if (strcmp(keyname,"f12")==0) {
        return DIK_F12;
    }
    else if (strcmp(keyname,"0")==0) { //Numbers!
        return DIK_0;
    }
    else if (strcmp(keyname,"1")==0) { 
        return DIK_1;
    }
    else if (strcmp(keyname,"2")==0) { 
        return DIK_2;
    }
    else if (strcmp(keyname,"3")==0) { 
        return DIK_3;
    }
    else if (strcmp(keyname,"4")==0) { 
        return DIK_4;
    }
    else if (strcmp(keyname,"5")==0) { 
        return DIK_5;
    }
    else if (strcmp(keyname,"6")==0) { 
        return DIK_6;
    }
    else if (strcmp(keyname,"7")==0) { 
        return DIK_7;
    }
    else if (strcmp(keyname,"8")==0) { 
        return DIK_8;
    }
    else if (strcmp(keyname,"9")==0) { 
        return DIK_9;
    }
    else if (strcmp(keyname,"a")==0) { //Letters!
        return DIK_A;
    }
    else if (strcmp(keyname,"b")==0) { 
        return DIK_B;
    }
    else if (strcmp(keyname,"c")==0) { 
        return DIK_C;
    }
    else if (strcmp(keyname,"d")==0) { 
        return DIK_D;
    }
    else if (strcmp(keyname,"e")==0) { 
        return DIK_E;
    }
    else if (strcmp(keyname,"f")==0) { 
        return DIK_F;
    }
    else if (strcmp(keyname,"g")==0) { 
        return DIK_G;
    }
    else if (strcmp(keyname,"h")==0) { 
        return DIK_H;
    }
    else if (strcmp(keyname,"i")==0) { 
        return DIK_I;
    }
    else if (strcmp(keyname,"j")==0) { 
        return DIK_J;
    }
    else if (strcmp(keyname,"k")==0) { 
        return DIK_K;
    }
    else if (strcmp(keyname,"l")==0) { 
        return DIK_L;
    }
    else if (strcmp(keyname,"m")==0) { 
        return DIK_M;
    }
    else if (strcmp(keyname,"n")==0) { 
        return DIK_N;
    }
    else if (strcmp(keyname,"o")==0) { 
        return DIK_O;
    }
    else if (strcmp(keyname,"p")==0) { 
        return DIK_P;
    }
    else if (strcmp(keyname,"q")==0) { 
        return DIK_Q;
    }
    else if (strcmp(keyname,"r")==0) { 
        return DIK_R;
    }
    else if (strcmp(keyname,"s")==0) { 
        return DIK_S;
    }
    else if (strcmp(keyname,"t")==0) { 
        return DIK_T;
    }
    else if (strcmp(keyname,"u")==0) { 
        return DIK_U;
    }
    else if (strcmp(keyname,"v")==0) { 
        return DIK_V;
    }
    else if (strcmp(keyname,"w")==0) { 
        return DIK_W;
    }
    else if (strcmp(keyname,"x")==0) { 
        return DIK_X;
    }
    else if (strcmp(keyname,"y")==0) { 
        return DIK_Y;
    }
    else if (strcmp(keyname,"z")==0) { 
        return DIK_Z;
    }
    else {
        return -1; //Sorry buddy, but these keys were not found
    }
    
} //Finally!! the end of the elseifs!

#endif
