"""
The Framework is a basic setup for DXPy that takes care of initialization
and allows for a lower learning curve, along with faster coding, running
on a standard, reuseable platform.

For more control, it is recommended that advanced projects create their own
initialization, but this will be enough for almost any user.
"""

#Imports DXPy
from dxpy import *

#sets the global variables
xpos,ypos,zpos =10,10,10
#Moves camera forward
def forward_move():
    global xpos,ypos,zpos
    ypos -= 0.1
    setcamera(xpos,ypos,zpos, 0.0,0.0,0.0,0.0,1.0,0.0)
#Moves camera backward
def back_move():
    global xpos,ypos,zpos
    ypos += 0.1
    setcamera(xpos,ypos,zpos, 0.0,0.0,0.0,0.0,1.0,0.0)
#Moves camera to the left
def left_move():
    global xpos,ypos,zpos
    xpos += 0.1
    setcamera(xpos,ypos,zpos, 0.0,0.0,0.0,0.0,1.0,0.0)
#Moves camera to the right
def right_move():
    global xpos,ypos,zpos
    xpos -= 0.1
    setcamera(xpos,ypos,zpos, 0.0,0.0,0.0,0.0,1.0,0.0)
def z_move():
    global xpos,ypos,zpos
    zpos += 0.1
    setcamera(xpos,ypos,zpos, 0.0,0.0,0.0,0.0,1.0,0.0)
def zr_move():
    global xpos,ypos,zpos
    zpos -= 0.1
    setcamera(xpos,ypos,zpos, 0,0,0,0,1,0)
def zr_move():
    global xpos,ypos,zpos
    zpos -= 0.1
    setcamera(xpos,ypos,zpos, 0,0,0,0,1,0)
#Runs on module import:

#Checks the version of DXPY, and shows a warning if versions do not match
#if version()!=0.1:
 #   msgbox("""The DXPy version of the Application does not match
#the version this application was made for! The program might not work!""","Warning!")

#Automatically creates a fullscreen Game
createwindow("  ",False,getscreenwidth()/2,getscreenheight()/2)

#Sets the background to black - the default is blue (As of DXPy 0.1)
#bgcolor(0,0,0)

#Quit on escape, yes. This is the default value, but just in case it changes
#in another version of DXPy, I set it anyway.
#escquit(True)
#use3dlights(False)
"""Overriding bindkeys is really simple:
calling another bindkey to a different function!
This is therefore changeable to the user's desire
"""
#Binds the wasd and arrow keys to move around the screen
bindkey("a",False,left_move)
bindkey("left",False,left_move)

bindkey("s",False,back_move)
bindkey("down",False,back_move)

bindkey("d",False,right_move)
bindkey("right",False,right_move)

bindkey("w",False,forward_move)
bindkey("up",False,forward_move)

bindkey("o",False,z_move)
bindkey("l",False,zr_move)


