"""
This file demonstrates useage of DXPy.

It is an RGB picker, allowing the user to
choose the amount of red, green and blue and display the amounts
"""
#imports all the functions from DXPY
from dxpy import * 

#VARIABLES

#defines specific amounts of red green and blue to start with
redamt,greenamt,blueamt=0,0,0

#FUNCTIONS

#These are functions that are called by the game
"""
A game is in a message loop, going about 60 times per second.
the functions that are called, each get called many times per second,
or until the user releases the key being pressed
"""
def red(): #called when the red key is pressed

    #gets the global variables available to the function
    global redamt, greenamt,blueamt
    #adds one to the red value
    redamt +=1
    #changes the background color of the game to the new color
    bgcolor(redamt,greenamt,blueamt)
    
def blue():#when blue pressed
    global redamt, greenamt,blueamt
    blueamt +=1
    bgcolor(redamt,greenamt,blueamt)
def green(): #when green pressed
    global redamt, greenamt,blueamt
    greenamt +=1
    bgcolor(redamt,greenamt,blueamt)

def showvalues():
    global redamt, greenamt,blueamt
    print "Red:",redamt
    print "Green:",greenamt
    print "Blue:",blueamt

#STARTER
print "RGB Picker"
print "Made by Daniel Kumor"

#version() gives the DXPY version.
if (version() != 0.2):
    """
        Msgbox() is your typical windows message box, it accepts two arguments:

        string, the text to be displayed in the message box
        string, the caption of the message box

        There is a warning with message boxes:
            First of all, if your games are full-screen, DO NOT USE THEM
            they will NOT show up. Use them only in windowed games, or
            like used here, before the window is created to check for
            dependencies/whatever

    """
    msgbox("""Warning: The DXPy version is different than the version
the application was made for.

There might be errors in execution if the functions called have changed!""",
           "Test Game Warning")

##

"""
CreateWindow creates the Game's main window. The arguments passed are:

string, the caption to be shown on top of the window
boolean, this specifies if fullscreen (1) or normal (anything else)
integer, the width of the window (resolution if fullscreen)
integer, the height of the window (resolution if fullscreen)

if fullscreen, width and height specify the resolution of the window

*******************************************************************
getscreenwidth() gets the current screen resolution width
getscreenheight() gets the current resolution height

these two functions allow the game to run in full-screen mode in a monitor's
native resolution
"""
createwindow("RGB Picker",False,400,200)

"""
Bindkey binds keyboard events with functions. It accepts 2 arguments:

string, the key to be bound. This is usually the name of the key.
    if the key is on both sides of the keyboard, a side definition is
    needed. EX: the left shift is "Lshift"

boolean, whether the function can be called only once per click, no matter
    how long the key is held. False to allow key-hold change/character movement,
    which calls the function about 60 times per second,
    and True to switch weapons/etc, where the function is called once per click

function, without parentheses, it gives the function that is to be called
    on the event. These functions are NOT to accept any parameters.
"""
#Binds the color changing keys
bindkey("r",False,red)
bindkey("b",False,blue)
bindkey("g",False,green)

#binds enter to show the values of each
bindkey("enter",True, showvalues)
"""
Changes the background color of the window RGB mode

integer, red amount
integer, green amounr
integer, blue amount 
"""
bgcolor(0,0,0)

#Pretty self explanatory. It starts the main game loop.
startgame()

